﻿using System;
using System.Diagnostics;
using System.Net;
using System.Net.Sockets;
using System.Threading;

class Program
{
    static Socket _serverSocket;

    static void Main(string[] args)
    {
        Console.WriteLine("Process ID: " + Process.GetCurrentProcess().Id);
        Thread t = new Thread(serverSockFunc);
        t.Start();

        Console.ReadLine();
    }

    private static void serverSockFunc(object obj)
    {
        try
        {
            using (_serverSocket = CreateServerSocket())
            {
                _serverSocket.Listen(5);

                while (_serverSocket != null)
                {
                    WriteLog("accept...");
                    using (Socket clntSocket = _serverSocket.Accept())
                    {
                        try
                        {
                            string inputText = clntSocket.ReadString();
                            clntSocket.WriteString("OK");
                        }
                        catch (Exception e)
                        {
                            Console.WriteLine(e.ToString());
                        }
                        clntSocket.Close();
                    }
                }
            }
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex.ToString());
        }
    }

    private static void WriteLog(string text)
    {
        Console.WriteLine(DateTime.Now + ": " + text);
    }

    private static Socket CreateServerSocket()
    {
        Socket socket = null;

        socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
        IPEndPoint ipEp = new IPEndPoint(IPAddress.Loopback, 57102);
        socket.Bind(ipEp);

        return socket;
    }
}
