﻿using System;
using System.Diagnostics;
using System.Net;
using System.Net.Sockets;
using System.Threading;

class Program
{
    static void Main(string[] args)
    {
        Console.WriteLine("Process ID: " + Process.GetCurrentProcess().Id);
        Thread t2 = new Thread(clntSockFunc);
        t2.Start();

        Console.ReadLine();
    }

    private static void clntSockFunc(object obj)
    {
        while (true)
        {
            Thread.Sleep(1000);

            try
            {
                using (var socket = CreateClientSocket())
                {
                    IPEndPoint ipEp = new IPEndPoint(IPAddress.Loopback, 57102);
                    socket.LingerState = new LingerOption(true, 0);
                    socket.Connect(ipEp);

                    try
                    {
                        socket.WriteString("test");
                        socket.ReadString();
                        // Thread.Sleep(1);

                        socket.Close();
                    }
                    catch (Exception e)
                    {
                        Console.WriteLine(e.ToString());
                    }
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.ToString());
            }
        }
    }

    private static void WriteLog(string text)
    {
        Console.WriteLine(DateTime.Now + ": " + text);
    }

    private static Socket CreateClientSocket()
    {
        return new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
    }

}

